unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dbf, BufDataset, db, Forms, Controls, Graphics, Dialogs,
  DBGrids, Grids, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Panel1: TPanel;
    procedure DBGrid1EditButtonClick(Sender: TObject);
    procedure DBGrid1PrepareCanvas(sender: TObject; DataCol: Integer;
      Column: TColumn; AState: TGridDrawState);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

const
  DB_NAME = 'test.db';

{ TForm1 }

procedure TForm1.DBGrid1PrepareCanvas(sender: TObject; DataCol: Integer;
  Column: TColumn; AState: TGridDrawState);
begin
  with Sender as TDBGrid do
  begin
    if DataCol in [0, 1] then begin
      Canvas.Brush.Color := DataSource.Dataset.FieldByName('BackColor').AsInteger;
      Canvas.Font.Color := DataSource.Dataset.FieldByName('TextColor').AsInteger;
    end else
    begin
      Canvas.Brush.Color := clWindow;
      canvas.Font.Color := clWindowText;
    end;

    if (gdSelected in AState) and Focused then
    begin
      Canvas.Brush.Color := clYellow;
      Canvas.Font.Color := clRed;
    end;
  end;
end;

procedure TForm1.DBGrid1EditButtonClick(Sender: TObject);
begin
    with (Sender As TDBGrid) do
    begin
    ShowMessage('Mach ein Fenster auf');
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  BufDataset1.FileName := DB_NAME;

  DBGrid1.Columns.Clear;
  with TColumn(DBGrid1.Columns.Add) do
  begin
    fieldname := 'Name';
    Title.Caption := 'Name';
    Width:=230;
    ButtonStyle:= cbsEllipsis;

    ReadOnly:=true;  //  <-- Hier ist das Problem ;-)

  end;

  with TColumn(DBGrid1.Columns.Add) do
  begin
    fieldname := 'Vorname';
    Title.Caption := 'Vorname';
    Width:=230;
  end;

  with TColumn(DBGrid1.Columns.Add) do
  begin
    fieldname := 'BackColor';
    Title.Caption := 'BackColor';
    Width:=100;
  end;

  with TColumn(DBGrid1.Columns.Add) do
  begin
    fieldname := 'TextColor';
    Title.Caption := 'TextColor';
    Width:=100;
  end;

  if not FileExists(DB_NAME) then
  begin
    BufDataset1.FieldDefs.Clear;
    BufDataset1.FieldDefs.Add('Name', ftString, 20);
    BufDataset1.FieldDefs.Add('Vorname', ftString, 10);
    Bufdataset1.FieldDefs.Add('BackColor', ftInteger);
    BufDataset1.FieldDefs.Add('TextColor', ftInteger);
    BufDataset1.CreateDataset;
    BufDataset1.Open;
    BufDataset1.InsertRecord(['abc', 'def', clRed, clYellow]);
    BufDataset1.InsertRecord(['123', '4', clBlue, clWhite]);
    BufDataset1.InsertRecord(['test', 'T.', clBlack, clSilver]);
  end else
    BufDataset1.Open;
end;

end.

